VERSION 5.00
Object = "{CAB249C7-BAC9-4C51-9526-12F29E40C4CE}#2.6#0"; "ExTvw.ocx"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   7403
   ClientLeft      =   5313
   ClientTop       =   2442
   ClientWidth     =   5742
   LinkTopic       =   "Form1"
   ScaleHeight     =   7403
   ScaleWidth      =   5742
   Begin VB.CommandButton Command 
      Caption         =   "CANCEL"
      BeginProperty Font 
         Name            =   "Verdana"
         Size            =   8.07
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   451
      Index           =   3
      Left            =   176
      TabIndex        =   4
      Top             =   5368
      Width           =   2563
   End
   Begin VB.CommandButton Command 
      Caption         =   "Finish"
      BeginProperty Font 
         Name            =   "Verdana"
         Size            =   8.07
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   451
      Index           =   2
      Left            =   2992
      TabIndex        =   3
      Top             =   5368
      Width           =   2563
   End
   Begin VB.CommandButton Command 
      Caption         =   "Jump to Previous Filter Result"
      BeginProperty Font 
         Name            =   "Verdana"
         Size            =   8.07
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   451
      Index           =   1
      Left            =   2992
      TabIndex        =   2
      Top             =   4884
      Width           =   2563
   End
   Begin VB.CommandButton Command 
      Caption         =   "Jump to Next Filter Result"
      BeginProperty Font 
         Name            =   "Verdana"
         Size            =   8.07
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   451
      Index           =   0
      Left            =   176
      TabIndex        =   1
      Top             =   4884
      Width           =   2563
   End
   Begin ExTvw.ExplorerTreeView ExplorerTreeView1 
      Height          =   4708
      Left            =   88
      TabIndex        =   0
      Top             =   88
      Width           =   5555
      _ExtentX        =   9794
      _ExtentY        =   8311
      Appearance      =   2
      DrivesOnly      =   -1  'True
      FileAttributes  =   63
      FireBeforeInsertItem=   15
      FolderAttributes=   63
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Verdana"
         Size            =   8.064
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      HotTracking     =   -1  'True
      IncludedItems   =   15
      Indent          =   19
      ItemHeight      =   19
      LimitEditInput  =   0   'False
      RootPath        =   "Arbeitsplatz"
      SingleExpand    =   2
   End
   Begin VB.Label Label2 
      Caption         =   "Label2"
      BeginProperty Font 
         Name            =   "Verdana"
         Size            =   8.07
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   627
      Left            =   176
      TabIndex        =   6
      Top             =   6600
      Width           =   5379
      WordWrap        =   -1  'True
   End
   Begin VB.Label Label1 
      Caption         =   "Label1"
      BeginProperty Font 
         Name            =   "Verdana"
         Size            =   8.07
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   627
      Left            =   176
      TabIndex        =   5
      Top             =   5896
      Width           =   5379
      WordWrap        =   -1  'True
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
 
'##############################################################
 
' Demo Project for TimoSoft Concerning "Find Filter Results"
' 04.09.2009/20.09.2009
'##############################################################
 
'{@}
Private ETV As ExplorerTreeView
Private CANCELLED As Boolean
'{@}
 
Option Explicit
 
Private Sub Form_Load()
    
   ' Reference to ExplorerTreeView
   Set ETV = ExplorerTreeView1
    
   ' Set and Apply Filters
   ' For Reasons of Simplicity only
   ' One Single File Filter
   With ETV
      '.FileFilters = "*.exe|*.frm|*.txt"
      .FileFilters = "*.exe|*.txt"
      .UseFileFilters = True
      .UseFolderFilters = False
   End With
    
End Sub
 
Private Sub Command_Click(Index As Integer)
    
   Select Case Index
          
      Case 0
         
         ' Next Filter Result:
         ' Search Downwards for the Next File, Matching Filter Settings,
         ' and Make it the Selected Tree Item
         CANCELLED = False
         Next_Filter_Result ETV.SelectedItem
         If CANCELLED Then
            ETV.SelectedItem = ETV.PathToItemHandle(Label2)
            ETV.ItemEnsureVisible ETV.PathToItemHandle(Label2)
         End If
         ETV.SetFocus
         
      Case 1
         ' Previous Filter Result:
         ' Search Upwards for the Next File, Matching Filter Settings,
         ' and Make it the Selected Tree Item
          
         ' Not Implemented Yet. Idea:
         ' Make a Correct "Next_Filter_Result"-Function/Sub
         ' Working into the Other Direction
          
      Case 2
         ' Finish
         Unload Me
         
      Case 3
         ' Cancel
         CANCELLED = True
          
   End Select
    
End Sub
 
Private Sub Next_Filter_Result(ByVal Selected_Item As Long)
    
   Dim l As Long
   Dim Next_Item As Long
    
   With ETV
       
      Next_Item = Find_Next_Match_In_Sub_Tree(Selected_Item)
      If Next_Item = -1 Then
          
         ' try parent item's next sibling sub-tree
         Next_Item = Selected_Item
          
         Do
            Next_Item = .ItemGetParentItem(Next_Item)
            ' special handling for ShowRoot = False
            If Next_Item = 0 Then Next_Item = -1
             
            If Next_Item = -1 Then
               ' we've reached the end of the tree
               Exit Do
            Else
               l = Next_Item
               Next_Item = .ItemGetNextItem(Next_Item)
            End If
             
            If Next_Item = -1 Then
               ' this parent does not have a sibling item
               Next_Item = l
            Else
               If Item_Matches_Filters(Next_Item) Then
                  ' we've found a match
                  Exit Do
               Else
                  l = Find_Next_Match_In_Sub_Tree(Next_Item)
                  If l <> -1 Then
                     ' we've found a match
                     Next_Item = l
                     Exit Do
                  End If
               End If
            End If
             
            ' Enable Cancelling
            DoEvents
            If CANCELLED Then Exit Sub
             
         Loop
          
      End If
       
      If Next_Item <> -1 Then
         ' we've found a result
         .SelectedItem = Next_Item
         .ItemEnsureVisible Next_Item
      End If
       
   End With
    
End Sub
 
Private Function Find_Next_Match_In_Sub_Tree(Base_Item As Long) As Long
    
   ' searches the sub-items of Base_Item *and the sibling items of Base_Item*
    
   Dim l As Long
   Dim Next_Item As Long
       
   ' Enable Cancelling
   DoEvents
   If CANCELLED Then Exit Function
    
   With ETV
       
      ' make sure the sub-items have been loaded
      If .ItemHandleToDisplayName(Base_Item) = "RECYCLER" Then
         Base_Item = .ItemGetNextItem(Base_Item)
      End If
      Label1 = .ItemHandleToDisplayName(Base_Item)
      Label2 = .ItemHandleToFSPath(Base_Item)
      .ItemLoadSubItems Base_Item
      Next_Item = .ItemGetFirstSubItem(Base_Item)
       
      If Next_Item = -1 Then
         ' the item does not have any sub-items, so try the next sibling item
         Next_Item = .ItemGetNextItem(Base_Item)
      End If
       
      Do While Next_Item <> -1
          
         ' we've found an item to investigate
         If Item_Matches_Filters(Next_Item) Then
            Find_Next_Match_In_Sub_Tree = Next_Item
            Exit Function
         End If
          
         ' this item doesn't match the filters, so investigate its sub-items
         l = Find_Next_Match_In_Sub_Tree(Next_Item)
         If l <> -1 Then
            ' a result has been found
            Find_Next_Match_In_Sub_Tree = l
            Exit Function
         End If
          
         ' no result has been found, so try the next sibling item
         Next_Item = .ItemGetNextItem(Next_Item)
          
         ' Enable Cancelling
         DoEvents
         If CANCELLED Then Exit Function
          
      Loop
       
   End With
    
   Find_Next_Match_In_Sub_Tree = -1
    
End Function
 
Private Function Item_Matches_Filters(Item As Long) As Boolean
    
   With ETV
       
      If .ItemIsPartOfFileSystem(Item) Then
         ' the item is of a type that can be filtered
          
         If (.ItemIsFile(Item) And .UseFileFilters) Or (.ItemIsFolder(Item) And .UseFolderFilters) Then
            ' filters are activated for this item type, so the item must match the filters
            Item_Matches_Filters = True
         End If
          
      End If
       
   End With
    
End Function
 
